Assignments Assignments

Public Member Functions | Static Public Member Functions | Private Member Functions | Private Attributes | List of all members
Ray::Union Class Reference

`#include <shapeList.h>`

Inheritance diagram for Ray::Union:

## Public Member Functions
std::string | name (void) const
void | init (const class LocalSceneData &data)
void | initOpenGL (void)
void | updateBoundingBox (void)
bool | isInside (Util::Point3D p) const
bool | processFirstIntersection (const Util::Ray3D &ray, const Util::BoundingBox1D &range, const RayIntersectionFilter &rFilter, const RayIntersectionKernel &rKernel, ShapeProcessingInfo spInfo, unsigned int tIdx) const
int | processAllIntersections (const Util::Ray3D &ray, const Util::BoundingBox1D &range, const RayIntersectionFilter &rFilter, const RayIntersectionKernel &rKernel, ShapeProcessingInfo spInfo, unsigned int tIdx) const
void | drawOpenGL (GLSLProgram *glslProgram) const
Public Member Functions inherited from Ray::Shape
virtual | ~Shape (void)
ShapeBoundingBox | boundingBox (void) const
virtual void | addTrianglesOpenGL (std::vector< class TriangleIndex > &triangles)
size_t | primitiveNum (void) const
virtual void | processOverlapping (const Filter &filter, const Kernel &kernel, ShapeProcessingInfo spInfo) const

## Static Public Member Functions
static std::string | Directive (void)
Static Public Member Functions inherited from Ray::Shape
static void | WriteInset (std::ostream &stream)

## Private Member Functions
void | _write (std::ostream &stream) const
void | _read (std::istream &stream)

## Private Attributes
ShapeList | _shapeList

## Additional Inherited Members
Public Types inherited from Ray::Shape
typedef std::function< ShapeProcessingInfo::ProcessingType(const ShapeProcessingInfo &, const Shape &) > | Filter
typedef std::function< void(const ShapeProcessingInfo &, const Shape &) > | Kernel
typedef std::function< bool(double) > | RayIntersectionFilter
typedef std::function< bool(const ShapeProcessingInfo &, const class RayShapeIntersectionInfo &) > | RayIntersectionKernel
Static Public Attributes inherited from Ray::Shape
static unsigned int | OpenGLTessellationComplexity
static unsigned int | WriteInsetSize = 0
Protected Attributes inherited from Ray::Shape
ShapeBoundingBox | _bBox
size_t | _primitiveNum

## Detailed Description

This class represents a node which stores the union of a set of shapes

## Member Function Documentation

## ◆ _read()

void Union::_read | ( | std::istream & | stream | ) |
| private virtual

This method reads the Shape from the stream (excluding the starting directive)

Implements Ray::Shape.

## ◆ _write()

void Union::_write | ( | std::ostream & | stream | ) | const
| private virtual

This method writes the Shape into the stream (including the starting directive)

Implements Ray::Shape.

## ◆ Directive()

static std::string Ray::Union::Directive | ( | void |  | ) |
| inline static

This static method returns the directive header describing the shape.

## ◆ drawOpenGL()

void Union::drawOpenGL | ( | GLSLProgram * | glslProgram | ) | const
| virtual

This method calls the necessary OpenGL commands to render the primitive.

Implements Ray::Shape.

## ◆ init()

void Union::init | ( | const class LocalSceneData & | data | ) |
| virtual

This method should be called (once) immediately after setting up the scene graph

Implements Ray::Shape.

## ◆ initOpenGL()

void Union::initOpenGL | ( | void |  | ) |
| virtual

This method should be called (once) after an OpenGL context has been created

Implements Ray::Shape.

## ◆ isInside()

bool Union::isInside | ( | Util::Point3D | p | ) | const
| virtual

This method determines if a point is inside a shape. It is assumed that if the shape is not water-tight, the method returns false.

Implements Ray::Shape.

## ◆ name()

std::string Ray::Union::name | ( | void |  | ) | const
| inline virtual

This method returns the name of the shape

Implements Ray::Shape.

## ◆ processAllIntersections()

int Union::processAllIntersections | ( | const Util::Ray3D & | ray,
|  | const Util::BoundingBox1D & | range,
|  | const RayIntersectionFilter & | rFilter,
|  | const RayIntersectionKernel & | rKernel,
|  | ShapeProcessingInfo | spInfo,
|  | unsigned int | tIdx ) const
| virtual

This method processes all shapes which intersect the ray within the prescribed range and passing the rFilter test, invoking the rKernel kernel with the intersection information. The processing terminates early if the kernel returns false. The function returns the number of valid intersections.

Implements Ray::Shape.

## ◆ processFirstIntersection()

bool Union::processFirstIntersection | ( | const Util::Ray3D & | ray,
|  | const Util::BoundingBox1D & | range,
|  | const RayIntersectionFilter & | rFilter,
|  | const RayIntersectionKernel & | rKernel,
|  | ShapeProcessingInfo | spInfo,
|  | unsigned int | tIdx ) const
| virtual

This method processes the first shape which intersect the ray within the prescribed range and passing the rFilter test, invoking the rKernel kernel with the intersection information. The function returns true if there was an intersection.

Implements Ray::Shape.

## ◆ updateBoundingBox()

void Union::updateBoundingBox | ( | void |  | ) |
| virtual

This method should be called to update the bounding boxes in the scene

Implements Ray::Shape.

## Member Data Documentation

## ◆ _shapeList

ShapeList Ray::Union::_shapeList
| private

The list of shapes

The documentation for this class was generated from the following files:

- Assignments/Ray/shapeList.h
- Assignments/Ray/shapeList.cpp
- Assignments/Ray/shapeList.todo.cpp